#!/usr/bin/env python

import os
from operator import *
from copy import copy

def read_file(name):
	res = []
	f = open(name).readlines()
	for l in f[:32]:
		l = l.strip().split('   ')
		res += l

	tot = 0.0
	nums = []
	bits = []

	for l in res:
		l = l.strip().split(" ")
		#print l
		n = float(l[3])
		#b = int(l[3][:1])
		#if not b:
		#	n = -n
		#print l[0], n
		tot += n
		nums.append(n)
		bits.append(l[1])
	
	avg = tot / 128.
	num_ok = 0
	lim = 0.0255
	for b, n in zip(bits, nums):
		if b:
			if n < avg + lim:
				num_ok += 1
		else:
			if n > avg + lim:
				num_ok += 1
		print b, n, n-avg
	print avg, num_ok

def print_match(bits, nums):

	#for n in nums:
	#	tot += n
	
	avg = 0 # tot / 128.
	num_ok = 0
	lim = 0
	for b, n in zip(bits, nums):
		if b:
			if n > avg + lim:
				num_ok += 1
		else:
			if n < avg + lim:
				num_ok += 1
		print b, n, n-avg
	print "ok:", num_ok

def read_res_file():
	res = []
	f = open("row.0.txt").readlines()
	for l in f[:32]:
		l = l.strip().split('   ')
		res += l

	tot = 0.0
	nums = []
	bits = []

	for l in res:
		l = l.strip().split(" ")
		#print l
		n = float(l[3])
		#b = int(l[3][:1])
		#if not b:
		#	n = -n
		#print l[0], n
		tot += n
		nums.append(n)
		bits.append(l[1])
	
	avg = tot / 128.
	num_ok = 0
	lim = 0.0255
	for b, n in zip(bits, nums):
		if b:
			if n < avg + lim:
				num_ok += 1
		else:
			if n > avg + lim:
				num_ok += 1
		print b, n, n-avg
	print avg, num_ok

def read_results_file(name):
	res = []
	key = []
	f = open(name).readlines()
	if len(f) != 129:
		return res, key
	for l in f[:128]:
		l = l.strip().split(" ")
		#print l
		res.append(float(l[1]))
		key.append(int(l[3][:1]))
	return res, key

def test1(name):
	res = []
	f = open(name).readlines()
	for l in f[:128]:
		l = l.strip().split(" ")
		#print l
		n = float(l[1])
		b = int(l[3][:1])
		if not b:
			n = -n
		print l[0], n

def calc_average_matches(key, k, include=[], exclude=[]):

	a = [0] * 128
	for fname, kr in k.items():
		if include:
			if fname not in include:
				continue
		elif fname in exclude:
			continue
		for i in range(128):
			if kr[i] < 0:
				if key[i] == 0:
					a[i] += 1
				else:
					a[i] -= 1
			if kr[i] > 0:
				if key[i] == 1:
					a[i] += 1
				else:
					a[i] -= 1
			
	return map(lambda x: (cmp(x, 0.0) + 1) / 2, a)

def calc_all_same(k, include=[], exclude=[]):

	a = [1] * 128
	for fname, kr in k.items():
		if include:
			if fname not in include:
				continue
		elif fname in exclude:
			continue
		k = map(lambda x: (cmp(x, 0.0) + 1) / 2, kr)
		a = map(lambda (x, y): x and y, zip(a, k))
			
	return a

def calc_all_same_matches(key, k, include=[], exclude=[]):

	a = [1] * 128
	for fname, kr in k.items():
		if include:
			if fname not in include:
				continue
		elif fname in exclude:
			continue
		for i in range(128):
			if kr[i] < 0:
				if key[i] == 0:
					a[i] = 0
			if kr[i] > 0:
				if key[i] == 1:
					a[i] = 0
			
	return a

calc_matches = calc_all_same_matches
#calc_matches = calc_average_matches

def find_least_bad(key, k, using):

	res = {}
	for fname in k.keys():
		if fname in using:
			continue
		include = copy(using) + [fname]
		a = calc_matches(key, k, include=include)
		new_match = reduce(add, a)
		if not res.has_key(new_match):
			res[new_match] = []
		res[new_match].append(fname)
	return res
		
def find_exclude(k, exclude_already, prev_match):

	res = {}
	for fname in k.keys():
		if fname in exclude_already:
			continue
		new_exclude = copy(exclude_already) + [fname]
		a = calc_matches(key, k, new_exclude)
		new_match = reduce(add, a)
		if new_match > prev_match:
			res[fname] = new_match
	
	return res

def add_up(k, fnames):

	tr = [0.0] * 128
	for fname in fnames:
		tr = map(lambda (x,y): x+y, zip(tr, k[fname]))
	return tr

def key_match_count(a, key):
	return reduce(add, map(lambda (x,y): x == y, zip(a, key)))

def test2():

	k = {}

	for fname in os.listdir("."):
		if fname[:4] != 'row.':
			continue
		res, key = read_results_file(fname)
		if res is None:
			continue
		k[fname] = map(lambda x: (cmp(x, 0.0) + 1) / 2, res)

	tr = add_up(k, k.keys())

	a = calc_matches(key, k)
	match_len = reduce(add, a)
	print a, 
	print key
	print_match(key, tr)

def test():

	k = {}

	for fname in os.listdir("."):
		if fname[:4] != 'row.':
			continue
		res, key = read_results_file(fname)
		if res is None:
			continue
		k[fname] = res

	tr = add_up(k, k.keys())

	a = calc_matches(key, k)
	match_len = reduce(add, a)
	print a, 
	print key
	print_match(key, tr)

	options = []
	for f in k.keys():
		options.append([f])

	added_some = 1
	matches = {}

	num_results = 20

	while added_some and num_results > 0:
		num_results -= 1
		added_some = 0

		for i in range(len(options)):
			includes = options[i]

			if not includes:
				continue


			counts = find_least_bad(key, k, includes)
			match_keys = counts.keys()
			match_keys.sort()
			if not match_keys:
				continue
			match_key = match_keys[-1]

			if match_key < 30:
				options[i] = []
				continue

			added_some = 1
			includes.append(counts[match_key][0])
			a = calc_matches(key, k, includes)
			kmc = key_match_count(a, key)

			print num_results, match_key, kmc, includes

			if not matches.has_key(kmc):
				matches[kmc] = []
			matches[kmc].append((match_key, kmc, copy(includes)))
		
	mkeys = matches.keys()
	mkeys.sort()
	#mkeys.reverse()
	fname_histogram = {}
	max_hist_count = 0
	ta = [0] * 128
	for i in range(len(mkeys)):
		mk = mkeys[i]
		for (match_key, kmc, includes) in matches[mk]:
			tr = add_up(k, includes)
			#a = calc_matches({None: tr})
			#match_len = reduce(add, a)
			print len(includes), match_key, kmc, includes  #, match_len
			print_match(key, tr)
			for fname in includes:
				if not fname_histogram.has_key(fname):
					fname_histogram[fname] = 0
				fname_histogram[fname] += match_key
				max_hist_count = max(max_hist_count, fname_histogram[fname])
			if mk <= len(mkeys) * 0.8:
				continue
			a = calc_all_same(k, include=includes)
			ta = map(lambda (x, y): x + y, zip(a, ta))

	count = 0
	max_ta = 0
	for x in range(len(ta)):
		max_ta = max(max_ta, ta[x])
		print x, ta[x], key[x]

	tt = [0.0] * 128
	for i in range(len(mkeys)):
		mk = mkeys[i]
		for (match_key, kmc, includes) in matches[mk]:
			if mk <= len(mkeys) * 0.8:
				continue
			tr = add_up(k, includes)
			tt = map(lambda (x, y): x + y, zip(tr, tt))
	
	#for x in range(len(ta)):
		#if ta[x] < max_ta * 0.9:
	#	if ta[x] < max_ta / 2:
	#		tt[x] = -tt[x]
	print_match(key, tt)

	#kcmp = map(xor, zip(ta, key))
	#most_used_printout(fname_histogram, max_hist_count, key, tr)

def most_used_printout(fname_histogram, max_hist_count, key, tr):

	fname_counts = {}
	for fname, count in fname_histogram.items():
		if not fname_counts.has_key(count):
			fname_counts[count] = []
		fname_counts[count].append(fname)

	most_used = []

	for c in range(max_hist_count):
		if not fname_counts.has_key(c):
			continue
		print c, fname_counts[c]
		if c >= max_hist_count * 0.8:
			for fname in fname_counts[c]:
				if fname not in most_used:
					most_used.append(fname)

	tr = add_up(k, most_used)
	print_match(key, tr)

if __name__ == '__main__':
	test()

